{
  Primer kako kreirati kljuceve u registry bazi koristeci native API funkcije
  Kljucevi se unose u formatu \Registry\*. Recimo, \Registry\Machine\SOFTWARE\test
  odgovara kljucu HKLM\SOFTWARE\test
}

{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE CONSOLE}

program NativeRegistry;

uses
  Windows;

const
  ntdll                = 'ntdll';
  OBJ_CASE_INSENSITIVE = 64;

type
  TUnicodeString  = packed record
                      Length        : WORD;
                      MaximumLength : WORD;
                      Buffer        : PWideChar;
                    end;
  UNICODE_STRING  = TUnicodeString;
  PUNICODE_STRING = ^UNICODE_STRING;

  TObjectAttributes  = packed record
                         Length                   : Cardinal;
                         RootDirectory            : LongWord;
                         ObjectName               : PUNICODE_STRING;
                         Attributes               : Cardinal;
                         SecurityDescriptor       : pointer;
                         SecurityQualityOfService : pointer;
                       end;
  OBJECT_ATTRIBUTES  = TObjectAttributes;
  POBJECT_ATTRIBUTES = ^OBJECT_ATTRIBUTES;


function NtCreateKey(var KeyHandle        : LongWord;
                         DesiredAccess    : Cardinal;
                     var ObjectAttributes : OBJECT_ATTRIBUTES;
                         TitleIndex       : Cardinal;
                         Class_           : PUNICODE_STRING;
                         CreateOptions    : Cardinal;
                     var Disposition      : Cardinal) : Cardinal; stdcall; external ntdll;

function NtSetValueKey(KeyHandle  : LongWord;
                       ValueName  : PUNICODE_STRING;
                       TitleIndex : Cardinal;
                       Type_      : Cardinal;
                       Data       : pointer;
                       DataSize   : Cardinal) : Cardinal; stdcall; external ntdll;

{function NtDeleteKey(KeyHandle : LongWord) : Cardinal; stdcall;
         external ntdll;}

procedure NtClose(KeyHandle : LongWord); external ntdll;


function NT_SUCCESS(status : Integer) : WordBool;
begin
  result := status >= 0;
end;

procedure InitializeObjectAttributes(var p : TObjectAttributes;
                                         n : PUNICODE_STRING;
                                         a : Cardinal;
                                         r : LongWord;
                                         s : pointer);
begin
  p.Length                   := SizeOf(OBJECT_ATTRIBUTES);
  p.RootDirectory            := r;
  p.Attributes               := a;
  p.ObjectName               := n;
  p.SecurityDescriptor       := s;
  p.SecurityQualityOfService := nil;
end;

procedure NativeCreateKey(keypath : AnsiString);
var
   KeyName          : UNICODE_STRING;
   hndKey           : LongWord;
   status           : Cardinal;
   ObjectAttributes : OBJECT_ATTRIBUTES;
   Disposition      : Cardinal;
   Buffer           : Array of WideChar;
begin
  keypath := keypath + #0;
  SetLength(Buffer, Length(keypath));
  MultiByteToWideChar(CP_UTF8,
                      0,
                      @keypath[1],
                      Length(keypath),
                      PWideChar(Buffer),
                      Length(Buffer));
  KeyName.Buffer := @Buffer[0];
  KeyName.Length := Length(keypath) * SizeOf(WideChar);
  InitializeObjectAttributes(ObjectAttributes,
                             @KeyName,
                             OBJ_CASE_INSENSITIVE,
                             0,
                             nil);
  status := NtCreateKey(hndKey,
                        KEY_ALL_ACCESS,
                        ObjectAttributes,
                        0,
                        nil,
                        REG_OPTION_NON_VOLATILE,
                        Disposition);
  If not NT_SUCCESS(status) then
    WriteLn('Kljuc nije kreiran ! (error: ', status, ')')
  else
    WriteLn('Kljuc uspesno kreiran !');

//  NtDeleteKey(hndKey);

  NtClose(hndKey);
end;

var
  key_path : String;

begin
  WriteLn('Puna putanja i naziv kljuca koji se kreira (u formatu \Registry\*): ');
  ReadLn(key_path);
  NativeCreateKey(key_path);
end.

